=== debian/changelog ===
ros-kinetic-librealsense (1.12.2-1xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Matt Curfman <matthew.c.curfman@intel.com>  Thu, 06 May 2021 10:07:33 -0000
